;Boot Sector for RavenOS 0.1.0    
;By Jon Lawton <lar1@bigfoot.com>

org 0       	                 ;We don't want NASM to mess with our addresses
jmp Start                          ;Keep the GDT and other data from being executed
%include "modules/boot/bpb.inc"    ;Include the BPB crap... (31 bytes!)
%include "modules/boot/gdt.inc"    ;Include the GDT (Global Descriptor Table)

[bits 16]
Start:                         
	mov ax, 0x7c0          ;Load 0x7c0 in to DS
	mov ds, ax             ;Not sure why, but the 486 needs this...
	
	mov ax, 0x1000
	mov es, ax
	mov ah, 0x02
	xor dl, dl
	;mov dh, [KernelH]
	;mov ch, [KernelC] 
	;mov cl, [KernelS]
	;mov al, [KernelSize]
	xor bx, bx
	int 0x13
	jc crap		

	cli                    ;Mask interupts
	mov al, 0x80           ;Stop NMIs as well
	out 0x70, al
	lgdt [gdt+2]           ;Load the gdt!
      mov eax, cr0           ;Copy Control Register 0 into EAX
      or al,1                ;Increment EAX (PMODE enable bit now 1)
      mov cr0, eax           ;Copy EAX into Control Register 0
	jmp short $+2          ;JMP to next line (Clear prefetch queue)
	jmp 0x08:pmode+7c00h   ;JMP to the 32 bit code!
crap:
	mov ax, 0xb800
	mov ds, ax
	cmp ah, 0x0
	mov [0000], word 0x0743
	jmp $
	
[bits 32]
pmode:                         ;Should be in PMODE now...
        mov ax, 0x10           ;Select data descriptor   
        mov ds, ax                
        mov [0xB8000], word 0x0741 ;Put a white 'A' in text video buffer
	jmp DWORD  0x08:0x10000  
	  jmp short $                ;Sit and do nothing (infinite Loop)

        times 510-($-$$) db 0  ;Move to offset 510 in the BS
        dw 0xAA55              ;Boot Sector identifier
